package com.flutter.my_plugin

import android.content.Context
import android.os.BatteryManager
import android.os.PowerManager
import androidx.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar
/** BatteryPlugin */
class MyPlugin: FlutterPlugin, MethodCallHandler {
  private lateinit var channel: MethodChannel
  private lateinit var applicationContext: Context

  constructor()

  constructor(context: Context) {
    applicationContext = context
  }

  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    applicationContext = flutterPluginBinding.applicationContext
    channel = MethodChannel(flutterPluginBinding.binaryMessenger, "battery_plugin")
    channel.setMethodCallHandler(this)
  }

  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
    if (call.method == "getBatteryCapacity") {
      var batteryCapacity = 0.0
      val powerProfile = "com.android.internal.os.PowerProfile"

      var powerProfileContext = Class.forName(powerProfile)
        .getConstructor(Context::class.java)
        .newInstance(applicationContext)

      batteryCapacity = Class
        .forName(powerProfile)
        .getMethod("getBatteryCapacity")
        .invoke(powerProfileContext) as Double

      result.success(batteryCapacity)
    } else {
      result.notImplemented()
    }
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
    channel.setMethodCallHandler(null)
  }
}
